part of plot_window;

class Color {
  static List<Color> Colors = [new Color(57,106,177),
      new Color(218,124,48),
      new Color(62,150,81),
      new Color(204,37,41),
      new Color(83,81,84),
      new Color(107,76,154),
      new Color(146,36,40),
      new Color(148,139,61)];

  static List<Color> ColorStops = [BLACK, new Color(0,0,255), new Color(0,255,255),
    new Color(0,255,0), new Color(255,255,0), new Color(255,0,0), WHITE];

  Color merge(Color other)=>new Color((this.red+other.red)~/2, (this.green+other.green)~/2, (this.blue+other.blue)~/2);
  Color mergeProportional(Color other, num thisStrength) {
    num otherStrength = 1.0 - thisStrength;
    return new Color((this.red*thisStrength + other.red*otherStrength).floor(),
        (this.green*thisStrength + other.green*otherStrength).floor(),
        (this.blue*thisStrength + other.blue*otherStrength).floor());
  }
  
  int red;
  int green;
  int blue;

  static Color BLACK = new Color(0,0,0);
  static Color WHITE = new Color(255,255,255);
  
  String toString()=>"#${red.toRadixString(16).padLeft(2, '0')}${green.toRadixString(16).padLeft(2, '0')}${blue.toRadixString(16).padLeft(2,'0')}";
  
  Color(int red, int green, int blue) {
    if (red <0 || red >255) red = 0;
    if (green <0 || green >255) green = 0;
    if (blue <0 || blue >255) blue = 0;
    this.red = red; this.green = green; this.blue = blue;
  }
}

class ColorIterator {
  int _i=-1;

  Color getNext() {
    _i++;
    return Color.Colors[_i%Color.Colors.length];
  }

}