part of plot_window;

class Heatmap implements Performable {
  String name;
  int _fixedPrecision;
  int get fixedPrecision=>_fixedPrecision;
  
  Color toColor(num n) {
    n = ((n-minCap)/(maxCap-minCap)).clamp(0,1);
    if (n==1) return Color.ColorStops.last;
    if (n==0) return Color.ColorStops.first;
    n = n*(Color.ColorStops.length-1);
    return Color.ColorStops[n~/1].mergeProportional(Color.ColorStops[(n+1)~/1], 1-n%1);
  }
  
  Performer get performer {
    SettingsGroup sg = new SettingsGroup(this.name)
    ..addPerformer(new StringSetting("Name", this.name, (String str) { this.name=str;}))
    ..addPerformer(new NumSetting("Maximum value", _maxCap??maxValue, (num n) { this.maxCap = n; }))
    ..addPerformer(new NumSetting("Minimum value", _minCap??minValue, (num n) { this.minCap = n; }));
    return sg;
  }

  num width;
  num height;
  num maxValue;
  num minValue;

  String get maxCapAsString {
    if (fixedPrecision==null)
      return "$maxCap";
    return maxCap.toStringAsFixed(fixedPrecision);
  }

  String get minCapAsString {
    if (fixedPrecision==null)
      return "$minCap";
    return minCap.toStringAsFixed(fixedPrecision);
  }

  num _maxCap;
  num _minCap;

  num get maxCap => _maxCap ?? maxValue;
  num get minCap => _minCap ?? minValue;
  void set maxCap(num n) {
    _maxCap=n;
    _fixedPrecision=null;
  }
  void set minCap(num n) {
    _minCap=n;
    _fixedPrecision=null;
  }
  
  List<List<num>> _values;
  List<List<num>> get values=>_values;

  Heatmap(this.name, this.width, this.height, this._values) {
    this._maxCap = null;
    this._minCap = null;
    this.maxValue = _values[0][0];
    this.minValue = _values[0][0];
    for (List<num> l in _values) {
      for (num n in l) {
        maxValue = math.max(maxValue, n);
        minValue = math.min(minValue, n);
      }
    }
    //    _fixedPrecision = math.max(-(math.log(maxValue-minValue)/math.LN10).floor(), 0);
    //    print("${(math.log(maxValue-minValue)/math.LN10).floor()}");
    //    print("minValue: $minValue maxValue: $maxValue, fixedPrecision: $fixedPrecision");
  }
  
}